Skip to main content
POST
/
applications
Create application
curl --request POST \
  --url https://api.blaxel.ai/v0/applications \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "metadata": {
    "name": "my-resource",
    "displayName": "My Resource",
    "externalId": "my-session-123",
    "labels": {}
  },
  "spec": {
    "enabled": true,
    "port": 8080,
    "region": "us-pdx-1",
    "revision": {
      "active": "<string>",
      "canary": "<string>",
      "canaryPercent": 10,
      "stickySessionTtl": 0,
      "traffic": 100
    },
    "revisions": [
      {
        "image": "<string>",
        "createdAt": "<string>",
        "createdBy": "<string>",
        "envs": [
          {
            "name": "MY_ENV_VAR",
            "secret": true,
            "value": "my-value"
          }
        ],
        "id": "<string>",
        "memory": 2048,
        "port": 8080
      }
    ],
    "urls": [
      {
        "domain": "app.example.com",
        "subdomain": "www"
      }
    ]
  }
}
'
{
  "metadata": {
    "name": "my-resource",
    "createdAt": "<string>",
    "updatedAt": "<string>",
    "createdBy": "<string>",
    "updatedBy": "<string>",
    "displayName": "My Resource",
    "externalId": "my-session-123",
    "labels": {},
    "plan": "<string>",
    "url": "<string>",
    "workspace": "<string>"
  },
  "spec": {
    "enabled": true,
    "port": 8080,
    "region": "us-pdx-1",
    "revision": {
      "active": "<string>",
      "canary": "<string>",
      "canaryPercent": 10,
      "stickySessionTtl": 0,
      "traffic": 100
    },
    "revisions": [
      {
        "image": "<string>",
        "createdAt": "<string>",
        "createdBy": "<string>",
        "envs": [
          {
            "name": "MY_ENV_VAR",
            "secret": true,
            "value": "my-value"
          }
        ],
        "id": "<string>",
        "memory": 2048,
        "port": 8080
      }
    ],
    "urls": [
      {
        "domain": "app.example.com",
        "subdomain": "www"
      }
    ]
  },
  "events": [
    {
      "canaryRevision": "<string>",
      "message": "Deployment successful",
      "revision": "rev-abc123",
      "status": "DEPLOYED",
      "time": "2025-01-15T10:30:00Z",
      "type": "deployment"
    }
  ],
  "status": "<string>"
}

Authorizations

Authorization
string
header
required

OAuth2 authentication with JWT tokens

Body

application/json

Long-running application deployment that runs your custom code as a publicly accessible endpoint. Applications are always public and use mk3 generation.

metadata
object
required

Common metadata fields shared by all Blaxel resources including name, labels, timestamps, and ownership information

spec
object
required

Configuration for an application including revision management, URL routing, and deployment region

Response

successful operation

Long-running application deployment that runs your custom code as a publicly accessible endpoint. Applications are always public and use mk3 generation.

metadata
object
required

Common metadata fields shared by all Blaxel resources including name, labels, timestamps, and ownership information

spec
object
required

Configuration for an application including revision management, URL routing, and deployment region

events
object[]
read-only

Events happening on a resource deployed on Blaxel

status
string
read-only

Application status computed from events

Last modified on June 22, 2026